# Welcome to the DotTiled contribution guide!

Thanks for taking the time to contribute to DotTiled!

## Contribution Guidelines

- **Branching:** Always branch from the latest `dev` branch. Do not submit PRs directly to `master`.
- **Git**: Keep your commits small with intentful messages. Use `git rebase` to keep your commit history clean, never merge `dev` into your branch. If you need to update your branch with the latest changes from `dev`, use `git rebase dev`.
- **Pull Requests:** Open PRs against the `dev` branch only. Use the `.github/PULL_REQUEST_TEMPLATE/dev_template.md` PR template for your description, and ensure your PR is well-documented.
- **Testing:** All changes to DotTiled core must include relevant tests. PRs without tests will not be accepted.
- **Examples & Misc:** Updates to example projects or documentation are more flexible but should still be submitted as PRs to `dev`.
- **Code Style:** Follow existing code style and conventions.

Thank you for helping improve DotTiled!